
local MakePlayerCharacter = require "prefabs/player_common"


local assets = {

        Asset( "ANIM", "anim/player_basic.zip" ),
        Asset( "ANIM", "anim/player_idles_shiver.zip" ),
        Asset( "ANIM", "anim/player_actions.zip" ),
        Asset( "ANIM", "anim/player_actions_axe.zip" ),
        Asset( "ANIM", "anim/player_actions_pickaxe.zip" ),
        Asset( "ANIM", "anim/player_actions_shovel.zip" ),
        Asset( "ANIM", "anim/player_actions_blowdart.zip" ),
        Asset( "ANIM", "anim/player_actions_eat.zip" ),
        Asset( "ANIM", "anim/player_actions_item.zip" ),
        Asset( "ANIM", "anim/player_actions_uniqueitem.zip" ),
        Asset( "ANIM", "anim/player_actions_bugnet.zip" ),
        Asset( "ANIM", "anim/player_actions_fishing.zip" ),
        Asset( "ANIM", "anim/player_actions_boomerang.zip" ),
        Asset( "ANIM", "anim/player_bush_hat.zip" ),
        Asset( "ANIM", "anim/player_attacks.zip" ),
        Asset( "ANIM", "anim/player_idles.zip" ),
        Asset( "ANIM", "anim/player_rebirth.zip" ),
        Asset( "ANIM", "anim/player_jump.zip" ),
        Asset( "ANIM", "anim/player_amulet_resurrect.zip" ),
        Asset( "ANIM", "anim/player_teleport.zip" ),
        Asset( "ANIM", "anim/wilson_fx.zip" ),
        Asset( "ANIM", "anim/player_one_man_band.zip" ),
        Asset( "ANIM", "anim/shadow_hands.zip" ),
        Asset( "SOUND", "sound/sfx.fsb" ),
        Asset( "SOUND", "sound/willow.fsb" ),
        Asset( "ANIM", "anim/beard.zip" ),

		-- Don't forget to include your character's custom assets!
        Asset( "ANIM", "anim/yuno.zip" ),
}
local prefabs = {}

local function Onsanitydelta(inst,data)
   if inst.components.sanity.current <= 190 and inst.components.sanity.current > 170 then
      inst.components.combat.damagemultiplier = 1.1
      inst.components.locomotor.walkspeed = (TUNING.WILSON_WALK_SPEED * 1.15)
      inst.components.locomotor.runspeed = (TUNING.WILSON_RUN_SPEED * 1.15)
   elseif  inst.components.sanity.current <= 170 and inst.components.sanity.current > 150 then
      inst.components.combat.damagemultiplier = 1.2
      inst.components.locomotor.walkspeed = (TUNING.WILSON_WALK_SPEED * 1.2)
      inst.components.locomotor.runspeed = (TUNING.WILSON_RUN_SPEED * 1.2)
   elseif  inst.components.sanity.current <= 150 and inst.components.sanity.current > 120 then
      inst.components.locomotor.walkspeed = (TUNING.WILSON_WALK_SPEED * 1.25)
      inst.components.locomotor.runspeed = (TUNING.WILSON_RUN_SPEED * 1.25)
      inst.components.combat.damagemultiplier = 1.3
      
      TUNING.SANITY_NIGHT_LIGHT = -20/60
	  
      TUNING.SANITY_NIGHT_MID = -20/60
   	
      TUNING.SANITY_NIGHT_DARK = -20/60
      TUNING.SANITY_DAY_GAIN = -20/60
   elseif  inst.components.sanity.current <= 120 and inst.components.sanity.current > 90 then
      inst.components.locomotor.walkspeed = (TUNING.WILSON_WALK_SPEED * 1.3)
      inst.components.locomotor.runspeed = (TUNING.WILSON_RUN_SPEED * 1.3)
      inst.components.combat.damagemultiplier = 1.4
   elseif  inst.components.sanity.current <= 90 then
      inst.components.locomotor.walkspeed = (TUNING.WILSON_WALK_SPEED * 1.35)
      inst.components.locomotor.runspeed = (TUNING.WILSON_RUN_SPEED * 1.35)
      inst.components.combat.damagemultiplier = 1.5
      
      TUNING.SANITY_NIGHT_LIGHT = -4/60
	  
      TUNING.SANITY_NIGHT_MID = -4/60
   	
      TUNING.SANITY_NIGHT_DARK = -4/60
      TUNING.SANITY_DAY_GAIN = -4/60
   elseif  inst.components.sanity.current > 90 then
      inst.components.locomotor.walkspeed = (TUNING.WILSON_WALK_SPEED * 1.4)
      inst.components.locomotor.runspeed = (TUNING.WILSON_RUN_SPEED * 1.4)
      
      TUNING.SANITY_NIGHT_LIGHT = -45/60
	  
      TUNING.SANITY_NIGHT_MID = -45/60
   	
      TUNING.SANITY_NIGHT_DARK = -45/60
      TUNING.SANITY_DAY_GAIN = -45/60
   end
   if IsDLCEnabled(REIGN_OF_GIANTS) or IsDLCEnabled(CAPY_DLC) then 
      if inst.components.sanity.current < 100 then
         inst.Light:Enable(true)
      else
         inst.Light:Enable(false)
      end
   end
end

local function Attack(inst,data)
   inst.components.sanity:DoDelta(5)
   if math.random() < 0.1 then
     inst.components.health:DoDelta(5)
   end
   return inst
end

local fn = function(inst)

	-- choose which sounds this character will play
	inst.soundsname = "willow"

	-- a minimap icon must be specified
	inst.MiniMapEntity:SetIcon( "yuno.tex" )

	-- todo: Add an example special power here.
  inst.components.health:SetMaxHealth( 100 )
  inst.components.hunger:SetMax(100 )
  inst.components.combat.damagemultiplier = 1.0
     
  inst.components.sanity:SetMax(200)
	inst.components.combat:SetAttackPeriod(0.25)
	inst.components.locomotor.walkspeed = (TUNING.WILSON_WALK_SPEED * 1.1)
	inst.components.locomotor.runspeed = (TUNING.WILSON_RUN_SPEED * 1.1)
  inst.components.hunger:SetRate(TUNING.WILSON_HUNGER_RATE * 1.2)
  inst:ListenForEvent("onhitother",Attack)
  inst.components.health:StartRegen(-1,30)

  if IsDLCEnabled(REIGN_OF_GIANTS) or IsDLCEnabled(CAPY_DLC) then 
	  inst.Light:SetRadius(9)
	  inst.Light:SetFalloff(1)
	  inst.Light:SetIntensity(.5)
	  inst.Light:SetColour(128/255,128/255,255/255)
	  inst.Light:Enable(false)
  end

  inst:ListenForEvent("sanitydelta",Onsanitydelta)

	return inst
end



-- strings! Any "yuno" below would have to be replaced by the prefab name of your character.

-- First up, the character select screen lines
-- note: these are lower-case character name
STRINGS.CHARACTER_TITLES.yuno = "Kindly Girl"
STRINGS.CHARACTER_NAMES.yuno = "Gasai Yuno"
STRINGS.CHARACTER_DESCRIPTIONS.yuno = "Very low health. She is stronger at night. \nShe can see in darkness."
STRINGS.CHARACTER_QUOTES.yuno = "\".....\""


return MakePlayerCharacter("yuno", prefabs, assets, fn)
